package container_test

import (
	"testing"

	containertest "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/container/test"
	"git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/rpc/message"
	messagetest "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/rpc/message/test"
)

func TestMessageConvert(t *testing.T) {
	messagetest.TestRPCMessage(t,
		func(empty bool) message.Message { return containertest.GenerateAttribute(empty) },
		func(empty bool) message.Message { return containertest.GenerateContainer(empty) },
		func(empty bool) message.Message { return containertest.GeneratePutRequestBody(empty) },
		func(empty bool) message.Message { return containertest.GeneratePutRequest(empty) },
		func(empty bool) message.Message { return containertest.GeneratePutResponseBody(empty) },
		func(empty bool) message.Message { return containertest.GeneratePutResponse(empty) },
		func(empty bool) message.Message { return containertest.GenerateGetRequestBody(empty) },
		func(empty bool) message.Message { return containertest.GenerateGetRequest(empty) },
		func(empty bool) message.Message { return containertest.GenerateGetResponseBody(empty) },
		func(empty bool) message.Message { return containertest.GenerateGetResponse(empty) },
		func(empty bool) message.Message { return containertest.GenerateDeleteRequestBody(empty) },
		func(empty bool) message.Message { return containertest.GenerateDeleteRequest(empty) },
		func(empty bool) message.Message { return containertest.GenerateDeleteResponseBody(empty) },
		func(empty bool) message.Message { return containertest.GenerateDeleteResponse(empty) },
		func(empty bool) message.Message { return containertest.GenerateListRequestBody(empty) },
		func(empty bool) message.Message { return containertest.GenerateListRequest(empty) },
		func(empty bool) message.Message { return containertest.GenerateListResponseBody(empty) },
		func(empty bool) message.Message { return containertest.GenerateListResponse(empty) },
		func(empty bool) message.Message { return containertest.GenerateGetRequestBody(empty) },
		func(empty bool) message.Message { return containertest.GenerateGetRequest(empty) },
		func(empty bool) message.Message { return containertest.GenerateGetResponseBody(empty) },
		func(empty bool) message.Message { return containertest.GenerateGetResponse(empty) },
	)
}
