// Code generated by protoc-gen-go-frostfs. DO NOT EDIT.

package object

import (
	json "encoding/json"
	fmt "fmt"
	grpc "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/refs/grpc"
	grpc1 "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/session/grpc"
	pool "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/util/pool"
	proto "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/util/proto"
	encoding "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/util/proto/encoding"
	easyproto "github.com/VictoriaMetrics/easyproto"
	jlexer "github.com/mailru/easyjson/jlexer"
	jwriter "github.com/mailru/easyjson/jwriter"
	strconv "strconv"
)

type ObjectType int32

const (
	ObjectType_REGULAR   ObjectType = 0
	ObjectType_TOMBSTONE ObjectType = 1
	ObjectType_LOCK      ObjectType = 3
)

var (
	ObjectType_name = map[int32]string{
		0: "REGULAR",
		1: "TOMBSTONE",
		3: "LOCK",
	}
	ObjectType_value = map[string]int32{
		"REGULAR":   0,
		"TOMBSTONE": 1,
		"LOCK":      3,
	}
)

func (x ObjectType) String() string {
	if v, ok := ObjectType_name[int32(x)]; ok {
		return v
	}
	return strconv.FormatInt(int64(x), 10)
}
func (x *ObjectType) FromString(s string) bool {
	if v, ok := ObjectType_value[s]; ok {
		*x = ObjectType(v)
		return true
	}
	return false
}

type MatchType int32

const (
	MatchType_MATCH_TYPE_UNSPECIFIED MatchType = 0
	MatchType_STRING_EQUAL           MatchType = 1
	MatchType_STRING_NOT_EQUAL       MatchType = 2
	MatchType_NOT_PRESENT            MatchType = 3
	MatchType_COMMON_PREFIX          MatchType = 4
)

var (
	MatchType_name = map[int32]string{
		0: "MATCH_TYPE_UNSPECIFIED",
		1: "STRING_EQUAL",
		2: "STRING_NOT_EQUAL",
		3: "NOT_PRESENT",
		4: "COMMON_PREFIX",
	}
	MatchType_value = map[string]int32{
		"MATCH_TYPE_UNSPECIFIED": 0,
		"STRING_EQUAL":           1,
		"STRING_NOT_EQUAL":       2,
		"NOT_PRESENT":            3,
		"COMMON_PREFIX":          4,
	}
)

func (x MatchType) String() string {
	if v, ok := MatchType_name[int32(x)]; ok {
		return v
	}
	return strconv.FormatInt(int64(x), 10)
}
func (x *MatchType) FromString(s string) bool {
	if v, ok := MatchType_value[s]; ok {
		*x = MatchType(v)
		return true
	}
	return false
}

type ShortHeader struct {
	Version         *grpc.Version  `json:"version"`
	CreationEpoch   uint64         `json:"creationEpoch"`
	OwnerId         *grpc.OwnerID  `json:"ownerID"`
	ObjectType      ObjectType     `json:"objectType"`
	PayloadLength   uint64         `json:"payloadLength"`
	PayloadHash     *grpc.Checksum `json:"payloadHash"`
	HomomorphicHash *grpc.Checksum `json:"homomorphicHash"`
}

var (
	_ encoding.ProtoMarshaler   = (*ShortHeader)(nil)
	_ encoding.ProtoUnmarshaler = (*ShortHeader)(nil)
	_ json.Marshaler            = (*ShortHeader)(nil)
	_ json.Unmarshaler          = (*ShortHeader)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *ShortHeader) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.NestedStructureSize(1, x.Version)
	size += proto.UInt64Size(2, x.CreationEpoch)
	size += proto.NestedStructureSize(3, x.OwnerId)
	size += proto.EnumSize(4, int32(x.ObjectType))
	size += proto.UInt64Size(5, x.PayloadLength)
	size += proto.NestedStructureSize(6, x.PayloadHash)
	size += proto.NestedStructureSize(7, x.HomomorphicHash)
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *ShortHeader) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *ShortHeader) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if x.Version != nil {
		x.Version.EmitProtobuf(mm.AppendMessage(1))
	}
	if x.CreationEpoch != 0 {
		mm.AppendUint64(2, x.CreationEpoch)
	}
	if x.OwnerId != nil {
		x.OwnerId.EmitProtobuf(mm.AppendMessage(3))
	}
	if int32(x.ObjectType) != 0 {
		mm.AppendInt32(4, int32(x.ObjectType))
	}
	if x.PayloadLength != 0 {
		mm.AppendUint64(5, x.PayloadLength)
	}
	if x.PayloadHash != nil {
		x.PayloadHash.EmitProtobuf(mm.AppendMessage(6))
	}
	if x.HomomorphicHash != nil {
		x.HomomorphicHash.EmitProtobuf(mm.AppendMessage(7))
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *ShortHeader) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "ShortHeader")
		}
		switch fc.FieldNum {
		case 1: // Version
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Version")
			}
			x.Version = new(grpc.Version)
			if err := x.Version.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 2: // CreationEpoch
			data, ok := fc.Uint64()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "CreationEpoch")
			}
			x.CreationEpoch = data
		case 3: // OwnerId
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "OwnerId")
			}
			x.OwnerId = new(grpc.OwnerID)
			if err := x.OwnerId.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 4: // ObjectType
			data, ok := fc.Int32()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "ObjectType")
			}
			x.ObjectType = ObjectType(data)
		case 5: // PayloadLength
			data, ok := fc.Uint64()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "PayloadLength")
			}
			x.PayloadLength = data
		case 6: // PayloadHash
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "PayloadHash")
			}
			x.PayloadHash = new(grpc.Checksum)
			if err := x.PayloadHash.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 7: // HomomorphicHash
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "HomomorphicHash")
			}
			x.HomomorphicHash = new(grpc.Checksum)
			if err := x.HomomorphicHash.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		}
	}
	return nil
}
func (x *ShortHeader) GetVersion() *grpc.Version {
	if x != nil {
		return x.Version
	}
	return nil
}
func (x *ShortHeader) SetVersion(v *grpc.Version) {
	x.Version = v
}
func (x *ShortHeader) GetCreationEpoch() uint64 {
	if x != nil {
		return x.CreationEpoch
	}
	return 0
}
func (x *ShortHeader) SetCreationEpoch(v uint64) {
	x.CreationEpoch = v
}
func (x *ShortHeader) GetOwnerId() *grpc.OwnerID {
	if x != nil {
		return x.OwnerId
	}
	return nil
}
func (x *ShortHeader) SetOwnerId(v *grpc.OwnerID) {
	x.OwnerId = v
}
func (x *ShortHeader) GetObjectType() ObjectType {
	if x != nil {
		return x.ObjectType
	}
	return 0
}
func (x *ShortHeader) SetObjectType(v ObjectType) {
	x.ObjectType = v
}
func (x *ShortHeader) GetPayloadLength() uint64 {
	if x != nil {
		return x.PayloadLength
	}
	return 0
}
func (x *ShortHeader) SetPayloadLength(v uint64) {
	x.PayloadLength = v
}
func (x *ShortHeader) GetPayloadHash() *grpc.Checksum {
	if x != nil {
		return x.PayloadHash
	}
	return nil
}
func (x *ShortHeader) SetPayloadHash(v *grpc.Checksum) {
	x.PayloadHash = v
}
func (x *ShortHeader) GetHomomorphicHash() *grpc.Checksum {
	if x != nil {
		return x.HomomorphicHash
	}
	return nil
}
func (x *ShortHeader) SetHomomorphicHash(v *grpc.Checksum) {
	x.HomomorphicHash = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *ShortHeader) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *ShortHeader) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"version\":"
		out.RawString(prefix)
		x.Version.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"creationEpoch\":"
		out.RawString(prefix)
		out.RawByte('"')
		out.Buffer.Buf = strconv.AppendUint(out.Buffer.Buf, x.CreationEpoch, 10)
		out.RawByte('"')
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"ownerID\":"
		out.RawString(prefix)
		x.OwnerId.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"objectType\":"
		out.RawString(prefix)
		v := int32(x.ObjectType)
		if vv, ok := ObjectType_name[v]; ok {
			out.String(vv)
		} else {
			out.Int32(v)
		}
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"payloadLength\":"
		out.RawString(prefix)
		out.RawByte('"')
		out.Buffer.Buf = strconv.AppendUint(out.Buffer.Buf, x.PayloadLength, 10)
		out.RawByte('"')
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"payloadHash\":"
		out.RawString(prefix)
		x.PayloadHash.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"homomorphicHash\":"
		out.RawString(prefix)
		x.HomomorphicHash.MarshalEasyJSON(out)
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *ShortHeader) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *ShortHeader) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "version":
			{
				var f *grpc.Version
				f = new(grpc.Version)
				f.UnmarshalEasyJSON(in)
				x.Version = f
			}
		case "creationEpoch":
			{
				var f uint64
				r := in.JsonNumber()
				n := r.String()
				v, err := strconv.ParseUint(n, 10, 64)
				if err != nil {
					in.AddError(err)
					return
				}
				pv := uint64(v)
				f = pv
				x.CreationEpoch = f
			}
		case "ownerID":
			{
				var f *grpc.OwnerID
				f = new(grpc.OwnerID)
				f.UnmarshalEasyJSON(in)
				x.OwnerId = f
			}
		case "objectType":
			{
				var f ObjectType
				var parsedValue ObjectType
				switch v := in.Interface().(type) {
				case string:
					if vv, ok := ObjectType_value[v]; ok {
						parsedValue = ObjectType(vv)
						break
					}
					vv, err := strconv.ParseInt(v, 10, 32)
					if err != nil {
						in.AddError(err)
						return
					}
					parsedValue = ObjectType(vv)
				case float64:
					parsedValue = ObjectType(v)
				}
				f = parsedValue
				x.ObjectType = f
			}
		case "payloadLength":
			{
				var f uint64
				r := in.JsonNumber()
				n := r.String()
				v, err := strconv.ParseUint(n, 10, 64)
				if err != nil {
					in.AddError(err)
					return
				}
				pv := uint64(v)
				f = pv
				x.PayloadLength = f
			}
		case "payloadHash":
			{
				var f *grpc.Checksum
				f = new(grpc.Checksum)
				f.UnmarshalEasyJSON(in)
				x.PayloadHash = f
			}
		case "homomorphicHash":
			{
				var f *grpc.Checksum
				f = new(grpc.Checksum)
				f.UnmarshalEasyJSON(in)
				x.HomomorphicHash = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type Header_Attribute struct {
	Key   string `json:"key"`
	Value string `json:"value"`
}

var (
	_ encoding.ProtoMarshaler   = (*Header_Attribute)(nil)
	_ encoding.ProtoUnmarshaler = (*Header_Attribute)(nil)
	_ json.Marshaler            = (*Header_Attribute)(nil)
	_ json.Unmarshaler          = (*Header_Attribute)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *Header_Attribute) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.StringSize(1, x.Key)
	size += proto.StringSize(2, x.Value)
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *Header_Attribute) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *Header_Attribute) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if len(x.Key) != 0 {
		mm.AppendString(1, x.Key)
	}
	if len(x.Value) != 0 {
		mm.AppendString(2, x.Value)
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *Header_Attribute) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "Header_Attribute")
		}
		switch fc.FieldNum {
		case 1: // Key
			data, ok := fc.String()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Key")
			}
			x.Key = data
		case 2: // Value
			data, ok := fc.String()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Value")
			}
			x.Value = data
		}
	}
	return nil
}
func (x *Header_Attribute) GetKey() string {
	if x != nil {
		return x.Key
	}
	return ""
}
func (x *Header_Attribute) SetKey(v string) {
	x.Key = v
}
func (x *Header_Attribute) GetValue() string {
	if x != nil {
		return x.Value
	}
	return ""
}
func (x *Header_Attribute) SetValue(v string) {
	x.Value = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *Header_Attribute) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *Header_Attribute) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"key\":"
		out.RawString(prefix)
		out.String(x.Key)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"value\":"
		out.RawString(prefix)
		out.String(x.Value)
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *Header_Attribute) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *Header_Attribute) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "key":
			{
				var f string
				f = in.String()
				x.Key = f
			}
		case "value":
			{
				var f string
				f = in.String()
				x.Value = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type Header_Split struct {
	Parent          *grpc.ObjectID  `json:"parent"`
	Previous        *grpc.ObjectID  `json:"previous"`
	ParentSignature *grpc.Signature `json:"parentSignature"`
	ParentHeader    *Header         `json:"parentHeader"`
	Children        []grpc.ObjectID `json:"children"`
	SplitId         []byte          `json:"splitID"`
}

var (
	_ encoding.ProtoMarshaler   = (*Header_Split)(nil)
	_ encoding.ProtoUnmarshaler = (*Header_Split)(nil)
	_ json.Marshaler            = (*Header_Split)(nil)
	_ json.Unmarshaler          = (*Header_Split)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *Header_Split) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.NestedStructureSize(1, x.Parent)
	size += proto.NestedStructureSize(2, x.Previous)
	size += proto.NestedStructureSize(3, x.ParentSignature)
	size += proto.NestedStructureSize(4, x.ParentHeader)
	for i := range x.Children {
		size += proto.NestedStructureSizeUnchecked(5, &x.Children[i])
	}
	size += proto.BytesSize(6, x.SplitId)
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *Header_Split) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *Header_Split) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if x.Parent != nil {
		x.Parent.EmitProtobuf(mm.AppendMessage(1))
	}
	if x.Previous != nil {
		x.Previous.EmitProtobuf(mm.AppendMessage(2))
	}
	if x.ParentSignature != nil {
		x.ParentSignature.EmitProtobuf(mm.AppendMessage(3))
	}
	if x.ParentHeader != nil {
		x.ParentHeader.EmitProtobuf(mm.AppendMessage(4))
	}
	for i := range x.Children {
		x.Children[i].EmitProtobuf(mm.AppendMessage(5))
	}
	if len(x.SplitId) != 0 {
		mm.AppendBytes(6, x.SplitId)
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *Header_Split) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "Header_Split")
		}
		switch fc.FieldNum {
		case 1: // Parent
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Parent")
			}
			x.Parent = new(grpc.ObjectID)
			if err := x.Parent.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 2: // Previous
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Previous")
			}
			x.Previous = new(grpc.ObjectID)
			if err := x.Previous.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 3: // ParentSignature
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "ParentSignature")
			}
			x.ParentSignature = new(grpc.Signature)
			if err := x.ParentSignature.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 4: // ParentHeader
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "ParentHeader")
			}
			x.ParentHeader = new(Header)
			if err := x.ParentHeader.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 5: // Children
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Children")
			}
			x.Children = append(x.Children, grpc.ObjectID{})
			ff := &x.Children[len(x.Children)-1]
			if err := ff.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 6: // SplitId
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "SplitId")
			}
			x.SplitId = data
		}
	}
	return nil
}
func (x *Header_Split) GetParent() *grpc.ObjectID {
	if x != nil {
		return x.Parent
	}
	return nil
}
func (x *Header_Split) SetParent(v *grpc.ObjectID) {
	x.Parent = v
}
func (x *Header_Split) GetPrevious() *grpc.ObjectID {
	if x != nil {
		return x.Previous
	}
	return nil
}
func (x *Header_Split) SetPrevious(v *grpc.ObjectID) {
	x.Previous = v
}
func (x *Header_Split) GetParentSignature() *grpc.Signature {
	if x != nil {
		return x.ParentSignature
	}
	return nil
}
func (x *Header_Split) SetParentSignature(v *grpc.Signature) {
	x.ParentSignature = v
}
func (x *Header_Split) GetParentHeader() *Header {
	if x != nil {
		return x.ParentHeader
	}
	return nil
}
func (x *Header_Split) SetParentHeader(v *Header) {
	x.ParentHeader = v
}
func (x *Header_Split) GetChildren() []grpc.ObjectID {
	if x != nil {
		return x.Children
	}
	return nil
}
func (x *Header_Split) SetChildren(v []grpc.ObjectID) {
	x.Children = v
}
func (x *Header_Split) GetSplitId() []byte {
	if x != nil {
		return x.SplitId
	}
	return nil
}
func (x *Header_Split) SetSplitId(v []byte) {
	x.SplitId = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *Header_Split) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *Header_Split) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"parent\":"
		out.RawString(prefix)
		x.Parent.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"previous\":"
		out.RawString(prefix)
		x.Previous.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"parentSignature\":"
		out.RawString(prefix)
		x.ParentSignature.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"parentHeader\":"
		out.RawString(prefix)
		x.ParentHeader.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"children\":"
		out.RawString(prefix)
		out.RawByte('[')
		for i := range x.Children {
			if i != 0 {
				out.RawByte(',')
			}
			x.Children[i].MarshalEasyJSON(out)
		}
		out.RawByte(']')
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"splitID\":"
		out.RawString(prefix)
		if x.SplitId != nil {
			out.Base64Bytes(x.SplitId)
		} else {
			out.String("")
		}
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *Header_Split) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *Header_Split) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "parent":
			{
				var f *grpc.ObjectID
				f = new(grpc.ObjectID)
				f.UnmarshalEasyJSON(in)
				x.Parent = f
			}
		case "previous":
			{
				var f *grpc.ObjectID
				f = new(grpc.ObjectID)
				f.UnmarshalEasyJSON(in)
				x.Previous = f
			}
		case "parentSignature":
			{
				var f *grpc.Signature
				f = new(grpc.Signature)
				f.UnmarshalEasyJSON(in)
				x.ParentSignature = f
			}
		case "parentHeader":
			{
				var f *Header
				f = new(Header)
				f.UnmarshalEasyJSON(in)
				x.ParentHeader = f
			}
		case "children":
			{
				var f grpc.ObjectID
				var list []grpc.ObjectID
				in.Delim('[')
				for !in.IsDelim(']') {
					f = grpc.ObjectID{}
					f.UnmarshalEasyJSON(in)
					list = append(list, f)
					in.WantComma()
				}
				x.Children = list
				in.Delim(']')
			}
		case "splitID":
			{
				var f []byte
				{
					tmp := in.Bytes()
					if len(tmp) == 0 {
						tmp = nil
					}
					f = tmp
				}
				x.SplitId = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type Header_EC struct {
	Parent              *grpc.ObjectID     `json:"parent"`
	Index               uint32             `json:"index"`
	Total               uint32             `json:"total"`
	HeaderLength        uint32             `json:"headerLength"`
	Header              []byte             `json:"header"`
	ParentSplitId       []byte             `json:"parentSplitID"`
	ParentSplitParentId *grpc.ObjectID     `json:"parentSplitParentID"`
	ParentAttributes    []Header_Attribute `json:"parentAttributes"`
}

var (
	_ encoding.ProtoMarshaler   = (*Header_EC)(nil)
	_ encoding.ProtoUnmarshaler = (*Header_EC)(nil)
	_ json.Marshaler            = (*Header_EC)(nil)
	_ json.Unmarshaler          = (*Header_EC)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *Header_EC) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.NestedStructureSize(1, x.Parent)
	size += proto.UInt32Size(2, x.Index)
	size += proto.UInt32Size(3, x.Total)
	size += proto.UInt32Size(4, x.HeaderLength)
	size += proto.BytesSize(5, x.Header)
	size += proto.BytesSize(6, x.ParentSplitId)
	size += proto.NestedStructureSize(7, x.ParentSplitParentId)
	for i := range x.ParentAttributes {
		size += proto.NestedStructureSizeUnchecked(8, &x.ParentAttributes[i])
	}
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *Header_EC) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *Header_EC) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if x.Parent != nil {
		x.Parent.EmitProtobuf(mm.AppendMessage(1))
	}
	if x.Index != 0 {
		mm.AppendUint32(2, x.Index)
	}
	if x.Total != 0 {
		mm.AppendUint32(3, x.Total)
	}
	if x.HeaderLength != 0 {
		mm.AppendUint32(4, x.HeaderLength)
	}
	if len(x.Header) != 0 {
		mm.AppendBytes(5, x.Header)
	}
	if len(x.ParentSplitId) != 0 {
		mm.AppendBytes(6, x.ParentSplitId)
	}
	if x.ParentSplitParentId != nil {
		x.ParentSplitParentId.EmitProtobuf(mm.AppendMessage(7))
	}
	for i := range x.ParentAttributes {
		x.ParentAttributes[i].EmitProtobuf(mm.AppendMessage(8))
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *Header_EC) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "Header_EC")
		}
		switch fc.FieldNum {
		case 1: // Parent
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Parent")
			}
			x.Parent = new(grpc.ObjectID)
			if err := x.Parent.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 2: // Index
			data, ok := fc.Uint32()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Index")
			}
			x.Index = data
		case 3: // Total
			data, ok := fc.Uint32()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Total")
			}
			x.Total = data
		case 4: // HeaderLength
			data, ok := fc.Uint32()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "HeaderLength")
			}
			x.HeaderLength = data
		case 5: // Header
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Header")
			}
			x.Header = data
		case 6: // ParentSplitId
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "ParentSplitId")
			}
			x.ParentSplitId = data
		case 7: // ParentSplitParentId
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "ParentSplitParentId")
			}
			x.ParentSplitParentId = new(grpc.ObjectID)
			if err := x.ParentSplitParentId.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 8: // ParentAttributes
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "ParentAttributes")
			}
			x.ParentAttributes = append(x.ParentAttributes, Header_Attribute{})
			ff := &x.ParentAttributes[len(x.ParentAttributes)-1]
			if err := ff.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		}
	}
	return nil
}
func (x *Header_EC) GetParent() *grpc.ObjectID {
	if x != nil {
		return x.Parent
	}
	return nil
}
func (x *Header_EC) SetParent(v *grpc.ObjectID) {
	x.Parent = v
}
func (x *Header_EC) GetIndex() uint32 {
	if x != nil {
		return x.Index
	}
	return 0
}
func (x *Header_EC) SetIndex(v uint32) {
	x.Index = v
}
func (x *Header_EC) GetTotal() uint32 {
	if x != nil {
		return x.Total
	}
	return 0
}
func (x *Header_EC) SetTotal(v uint32) {
	x.Total = v
}
func (x *Header_EC) GetHeaderLength() uint32 {
	if x != nil {
		return x.HeaderLength
	}
	return 0
}
func (x *Header_EC) SetHeaderLength(v uint32) {
	x.HeaderLength = v
}
func (x *Header_EC) GetHeader() []byte {
	if x != nil {
		return x.Header
	}
	return nil
}
func (x *Header_EC) SetHeader(v []byte) {
	x.Header = v
}
func (x *Header_EC) GetParentSplitId() []byte {
	if x != nil {
		return x.ParentSplitId
	}
	return nil
}
func (x *Header_EC) SetParentSplitId(v []byte) {
	x.ParentSplitId = v
}
func (x *Header_EC) GetParentSplitParentId() *grpc.ObjectID {
	if x != nil {
		return x.ParentSplitParentId
	}
	return nil
}
func (x *Header_EC) SetParentSplitParentId(v *grpc.ObjectID) {
	x.ParentSplitParentId = v
}
func (x *Header_EC) GetParentAttributes() []Header_Attribute {
	if x != nil {
		return x.ParentAttributes
	}
	return nil
}
func (x *Header_EC) SetParentAttributes(v []Header_Attribute) {
	x.ParentAttributes = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *Header_EC) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *Header_EC) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"parent\":"
		out.RawString(prefix)
		x.Parent.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"index\":"
		out.RawString(prefix)
		out.Uint32(x.Index)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"total\":"
		out.RawString(prefix)
		out.Uint32(x.Total)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"headerLength\":"
		out.RawString(prefix)
		out.Uint32(x.HeaderLength)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"header\":"
		out.RawString(prefix)
		if x.Header != nil {
			out.Base64Bytes(x.Header)
		} else {
			out.String("")
		}
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"parentSplitID\":"
		out.RawString(prefix)
		if x.ParentSplitId != nil {
			out.Base64Bytes(x.ParentSplitId)
		} else {
			out.String("")
		}
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"parentSplitParentID\":"
		out.RawString(prefix)
		x.ParentSplitParentId.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"parentAttributes\":"
		out.RawString(prefix)
		out.RawByte('[')
		for i := range x.ParentAttributes {
			if i != 0 {
				out.RawByte(',')
			}
			x.ParentAttributes[i].MarshalEasyJSON(out)
		}
		out.RawByte(']')
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *Header_EC) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *Header_EC) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "parent":
			{
				var f *grpc.ObjectID
				f = new(grpc.ObjectID)
				f.UnmarshalEasyJSON(in)
				x.Parent = f
			}
		case "index":
			{
				var f uint32
				r := in.JsonNumber()
				n := r.String()
				v, err := strconv.ParseUint(n, 10, 32)
				if err != nil {
					in.AddError(err)
					return
				}
				pv := uint32(v)
				f = pv
				x.Index = f
			}
		case "total":
			{
				var f uint32
				r := in.JsonNumber()
				n := r.String()
				v, err := strconv.ParseUint(n, 10, 32)
				if err != nil {
					in.AddError(err)
					return
				}
				pv := uint32(v)
				f = pv
				x.Total = f
			}
		case "headerLength":
			{
				var f uint32
				r := in.JsonNumber()
				n := r.String()
				v, err := strconv.ParseUint(n, 10, 32)
				if err != nil {
					in.AddError(err)
					return
				}
				pv := uint32(v)
				f = pv
				x.HeaderLength = f
			}
		case "header":
			{
				var f []byte
				{
					tmp := in.Bytes()
					if len(tmp) == 0 {
						tmp = nil
					}
					f = tmp
				}
				x.Header = f
			}
		case "parentSplitID":
			{
				var f []byte
				{
					tmp := in.Bytes()
					if len(tmp) == 0 {
						tmp = nil
					}
					f = tmp
				}
				x.ParentSplitId = f
			}
		case "parentSplitParentID":
			{
				var f *grpc.ObjectID
				f = new(grpc.ObjectID)
				f.UnmarshalEasyJSON(in)
				x.ParentSplitParentId = f
			}
		case "parentAttributes":
			{
				var f Header_Attribute
				var list []Header_Attribute
				in.Delim('[')
				for !in.IsDelim(']') {
					f = Header_Attribute{}
					f.UnmarshalEasyJSON(in)
					list = append(list, f)
					in.WantComma()
				}
				x.ParentAttributes = list
				in.Delim(']')
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type Header struct {
	Version         *grpc.Version       `json:"version"`
	ContainerId     *grpc.ContainerID   `json:"containerID"`
	OwnerId         *grpc.OwnerID       `json:"ownerID"`
	CreationEpoch   uint64              `json:"creationEpoch"`
	PayloadLength   uint64              `json:"payloadLength"`
	PayloadHash     *grpc.Checksum      `json:"payloadHash"`
	ObjectType      ObjectType          `json:"objectType"`
	HomomorphicHash *grpc.Checksum      `json:"homomorphicHash"`
	SessionToken    *grpc1.SessionToken `json:"sessionToken"`
	Attributes      []Header_Attribute  `json:"attributes"`
	Split           *Header_Split       `json:"split"`
	Ec              *Header_EC          `json:"ec"`
}

var (
	_ encoding.ProtoMarshaler   = (*Header)(nil)
	_ encoding.ProtoUnmarshaler = (*Header)(nil)
	_ json.Marshaler            = (*Header)(nil)
	_ json.Unmarshaler          = (*Header)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *Header) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.NestedStructureSize(1, x.Version)
	size += proto.NestedStructureSize(2, x.ContainerId)
	size += proto.NestedStructureSize(3, x.OwnerId)
	size += proto.UInt64Size(4, x.CreationEpoch)
	size += proto.UInt64Size(5, x.PayloadLength)
	size += proto.NestedStructureSize(6, x.PayloadHash)
	size += proto.EnumSize(7, int32(x.ObjectType))
	size += proto.NestedStructureSize(8, x.HomomorphicHash)
	size += proto.NestedStructureSize(9, x.SessionToken)
	for i := range x.Attributes {
		size += proto.NestedStructureSizeUnchecked(10, &x.Attributes[i])
	}
	size += proto.NestedStructureSize(11, x.Split)
	size += proto.NestedStructureSize(12, x.Ec)
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *Header) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *Header) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if x.Version != nil {
		x.Version.EmitProtobuf(mm.AppendMessage(1))
	}
	if x.ContainerId != nil {
		x.ContainerId.EmitProtobuf(mm.AppendMessage(2))
	}
	if x.OwnerId != nil {
		x.OwnerId.EmitProtobuf(mm.AppendMessage(3))
	}
	if x.CreationEpoch != 0 {
		mm.AppendUint64(4, x.CreationEpoch)
	}
	if x.PayloadLength != 0 {
		mm.AppendUint64(5, x.PayloadLength)
	}
	if x.PayloadHash != nil {
		x.PayloadHash.EmitProtobuf(mm.AppendMessage(6))
	}
	if int32(x.ObjectType) != 0 {
		mm.AppendInt32(7, int32(x.ObjectType))
	}
	if x.HomomorphicHash != nil {
		x.HomomorphicHash.EmitProtobuf(mm.AppendMessage(8))
	}
	if x.SessionToken != nil {
		x.SessionToken.EmitProtobuf(mm.AppendMessage(9))
	}
	for i := range x.Attributes {
		x.Attributes[i].EmitProtobuf(mm.AppendMessage(10))
	}
	if x.Split != nil {
		x.Split.EmitProtobuf(mm.AppendMessage(11))
	}
	if x.Ec != nil {
		x.Ec.EmitProtobuf(mm.AppendMessage(12))
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *Header) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "Header")
		}
		switch fc.FieldNum {
		case 1: // Version
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Version")
			}
			x.Version = new(grpc.Version)
			if err := x.Version.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 2: // ContainerId
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "ContainerId")
			}
			x.ContainerId = new(grpc.ContainerID)
			if err := x.ContainerId.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 3: // OwnerId
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "OwnerId")
			}
			x.OwnerId = new(grpc.OwnerID)
			if err := x.OwnerId.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 4: // CreationEpoch
			data, ok := fc.Uint64()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "CreationEpoch")
			}
			x.CreationEpoch = data
		case 5: // PayloadLength
			data, ok := fc.Uint64()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "PayloadLength")
			}
			x.PayloadLength = data
		case 6: // PayloadHash
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "PayloadHash")
			}
			x.PayloadHash = new(grpc.Checksum)
			if err := x.PayloadHash.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 7: // ObjectType
			data, ok := fc.Int32()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "ObjectType")
			}
			x.ObjectType = ObjectType(data)
		case 8: // HomomorphicHash
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "HomomorphicHash")
			}
			x.HomomorphicHash = new(grpc.Checksum)
			if err := x.HomomorphicHash.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 9: // SessionToken
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "SessionToken")
			}
			x.SessionToken = new(grpc1.SessionToken)
			if err := x.SessionToken.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 10: // Attributes
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Attributes")
			}
			x.Attributes = append(x.Attributes, Header_Attribute{})
			ff := &x.Attributes[len(x.Attributes)-1]
			if err := ff.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 11: // Split
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Split")
			}
			x.Split = new(Header_Split)
			if err := x.Split.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 12: // Ec
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Ec")
			}
			x.Ec = new(Header_EC)
			if err := x.Ec.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		}
	}
	return nil
}
func (x *Header) GetVersion() *grpc.Version {
	if x != nil {
		return x.Version
	}
	return nil
}
func (x *Header) SetVersion(v *grpc.Version) {
	x.Version = v
}
func (x *Header) GetContainerId() *grpc.ContainerID {
	if x != nil {
		return x.ContainerId
	}
	return nil
}
func (x *Header) SetContainerId(v *grpc.ContainerID) {
	x.ContainerId = v
}
func (x *Header) GetOwnerId() *grpc.OwnerID {
	if x != nil {
		return x.OwnerId
	}
	return nil
}
func (x *Header) SetOwnerId(v *grpc.OwnerID) {
	x.OwnerId = v
}
func (x *Header) GetCreationEpoch() uint64 {
	if x != nil {
		return x.CreationEpoch
	}
	return 0
}
func (x *Header) SetCreationEpoch(v uint64) {
	x.CreationEpoch = v
}
func (x *Header) GetPayloadLength() uint64 {
	if x != nil {
		return x.PayloadLength
	}
	return 0
}
func (x *Header) SetPayloadLength(v uint64) {
	x.PayloadLength = v
}
func (x *Header) GetPayloadHash() *grpc.Checksum {
	if x != nil {
		return x.PayloadHash
	}
	return nil
}
func (x *Header) SetPayloadHash(v *grpc.Checksum) {
	x.PayloadHash = v
}
func (x *Header) GetObjectType() ObjectType {
	if x != nil {
		return x.ObjectType
	}
	return 0
}
func (x *Header) SetObjectType(v ObjectType) {
	x.ObjectType = v
}
func (x *Header) GetHomomorphicHash() *grpc.Checksum {
	if x != nil {
		return x.HomomorphicHash
	}
	return nil
}
func (x *Header) SetHomomorphicHash(v *grpc.Checksum) {
	x.HomomorphicHash = v
}
func (x *Header) GetSessionToken() *grpc1.SessionToken {
	if x != nil {
		return x.SessionToken
	}
	return nil
}
func (x *Header) SetSessionToken(v *grpc1.SessionToken) {
	x.SessionToken = v
}
func (x *Header) GetAttributes() []Header_Attribute {
	if x != nil {
		return x.Attributes
	}
	return nil
}
func (x *Header) SetAttributes(v []Header_Attribute) {
	x.Attributes = v
}
func (x *Header) GetSplit() *Header_Split {
	if x != nil {
		return x.Split
	}
	return nil
}
func (x *Header) SetSplit(v *Header_Split) {
	x.Split = v
}
func (x *Header) GetEc() *Header_EC {
	if x != nil {
		return x.Ec
	}
	return nil
}
func (x *Header) SetEc(v *Header_EC) {
	x.Ec = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *Header) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *Header) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"version\":"
		out.RawString(prefix)
		x.Version.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"containerID\":"
		out.RawString(prefix)
		x.ContainerId.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"ownerID\":"
		out.RawString(prefix)
		x.OwnerId.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"creationEpoch\":"
		out.RawString(prefix)
		out.RawByte('"')
		out.Buffer.Buf = strconv.AppendUint(out.Buffer.Buf, x.CreationEpoch, 10)
		out.RawByte('"')
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"payloadLength\":"
		out.RawString(prefix)
		out.RawByte('"')
		out.Buffer.Buf = strconv.AppendUint(out.Buffer.Buf, x.PayloadLength, 10)
		out.RawByte('"')
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"payloadHash\":"
		out.RawString(prefix)
		x.PayloadHash.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"objectType\":"
		out.RawString(prefix)
		v := int32(x.ObjectType)
		if vv, ok := ObjectType_name[v]; ok {
			out.String(vv)
		} else {
			out.Int32(v)
		}
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"homomorphicHash\":"
		out.RawString(prefix)
		x.HomomorphicHash.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"sessionToken\":"
		out.RawString(prefix)
		x.SessionToken.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"attributes\":"
		out.RawString(prefix)
		out.RawByte('[')
		for i := range x.Attributes {
			if i != 0 {
				out.RawByte(',')
			}
			x.Attributes[i].MarshalEasyJSON(out)
		}
		out.RawByte(']')
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"split\":"
		out.RawString(prefix)
		x.Split.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"ec\":"
		out.RawString(prefix)
		x.Ec.MarshalEasyJSON(out)
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *Header) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *Header) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "version":
			{
				var f *grpc.Version
				f = new(grpc.Version)
				f.UnmarshalEasyJSON(in)
				x.Version = f
			}
		case "containerID":
			{
				var f *grpc.ContainerID
				f = new(grpc.ContainerID)
				f.UnmarshalEasyJSON(in)
				x.ContainerId = f
			}
		case "ownerID":
			{
				var f *grpc.OwnerID
				f = new(grpc.OwnerID)
				f.UnmarshalEasyJSON(in)
				x.OwnerId = f
			}
		case "creationEpoch":
			{
				var f uint64
				r := in.JsonNumber()
				n := r.String()
				v, err := strconv.ParseUint(n, 10, 64)
				if err != nil {
					in.AddError(err)
					return
				}
				pv := uint64(v)
				f = pv
				x.CreationEpoch = f
			}
		case "payloadLength":
			{
				var f uint64
				r := in.JsonNumber()
				n := r.String()
				v, err := strconv.ParseUint(n, 10, 64)
				if err != nil {
					in.AddError(err)
					return
				}
				pv := uint64(v)
				f = pv
				x.PayloadLength = f
			}
		case "payloadHash":
			{
				var f *grpc.Checksum
				f = new(grpc.Checksum)
				f.UnmarshalEasyJSON(in)
				x.PayloadHash = f
			}
		case "objectType":
			{
				var f ObjectType
				var parsedValue ObjectType
				switch v := in.Interface().(type) {
				case string:
					if vv, ok := ObjectType_value[v]; ok {
						parsedValue = ObjectType(vv)
						break
					}
					vv, err := strconv.ParseInt(v, 10, 32)
					if err != nil {
						in.AddError(err)
						return
					}
					parsedValue = ObjectType(vv)
				case float64:
					parsedValue = ObjectType(v)
				}
				f = parsedValue
				x.ObjectType = f
			}
		case "homomorphicHash":
			{
				var f *grpc.Checksum
				f = new(grpc.Checksum)
				f.UnmarshalEasyJSON(in)
				x.HomomorphicHash = f
			}
		case "sessionToken":
			{
				var f *grpc1.SessionToken
				f = new(grpc1.SessionToken)
				f.UnmarshalEasyJSON(in)
				x.SessionToken = f
			}
		case "attributes":
			{
				var f Header_Attribute
				var list []Header_Attribute
				in.Delim('[')
				for !in.IsDelim(']') {
					f = Header_Attribute{}
					f.UnmarshalEasyJSON(in)
					list = append(list, f)
					in.WantComma()
				}
				x.Attributes = list
				in.Delim(']')
			}
		case "split":
			{
				var f *Header_Split
				f = new(Header_Split)
				f.UnmarshalEasyJSON(in)
				x.Split = f
			}
		case "ec":
			{
				var f *Header_EC
				f = new(Header_EC)
				f.UnmarshalEasyJSON(in)
				x.Ec = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type Object struct {
	ObjectId  *grpc.ObjectID  `json:"objectID"`
	Signature *grpc.Signature `json:"signature"`
	Header    *Header         `json:"header"`
	Payload   []byte          `json:"payload"`
}

var (
	_ encoding.ProtoMarshaler   = (*Object)(nil)
	_ encoding.ProtoUnmarshaler = (*Object)(nil)
	_ json.Marshaler            = (*Object)(nil)
	_ json.Unmarshaler          = (*Object)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *Object) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.NestedStructureSize(1, x.ObjectId)
	size += proto.NestedStructureSize(2, x.Signature)
	size += proto.NestedStructureSize(3, x.Header)
	size += proto.BytesSize(4, x.Payload)
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *Object) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *Object) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if x.ObjectId != nil {
		x.ObjectId.EmitProtobuf(mm.AppendMessage(1))
	}
	if x.Signature != nil {
		x.Signature.EmitProtobuf(mm.AppendMessage(2))
	}
	if x.Header != nil {
		x.Header.EmitProtobuf(mm.AppendMessage(3))
	}
	if len(x.Payload) != 0 {
		mm.AppendBytes(4, x.Payload)
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *Object) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "Object")
		}
		switch fc.FieldNum {
		case 1: // ObjectId
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "ObjectId")
			}
			x.ObjectId = new(grpc.ObjectID)
			if err := x.ObjectId.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 2: // Signature
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Signature")
			}
			x.Signature = new(grpc.Signature)
			if err := x.Signature.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 3: // Header
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Header")
			}
			x.Header = new(Header)
			if err := x.Header.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 4: // Payload
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Payload")
			}
			x.Payload = data
		}
	}
	return nil
}
func (x *Object) GetObjectId() *grpc.ObjectID {
	if x != nil {
		return x.ObjectId
	}
	return nil
}
func (x *Object) SetObjectId(v *grpc.ObjectID) {
	x.ObjectId = v
}
func (x *Object) GetSignature() *grpc.Signature {
	if x != nil {
		return x.Signature
	}
	return nil
}
func (x *Object) SetSignature(v *grpc.Signature) {
	x.Signature = v
}
func (x *Object) GetHeader() *Header {
	if x != nil {
		return x.Header
	}
	return nil
}
func (x *Object) SetHeader(v *Header) {
	x.Header = v
}
func (x *Object) GetPayload() []byte {
	if x != nil {
		return x.Payload
	}
	return nil
}
func (x *Object) SetPayload(v []byte) {
	x.Payload = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *Object) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *Object) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"objectID\":"
		out.RawString(prefix)
		x.ObjectId.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"signature\":"
		out.RawString(prefix)
		x.Signature.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"header\":"
		out.RawString(prefix)
		x.Header.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"payload\":"
		out.RawString(prefix)
		if x.Payload != nil {
			out.Base64Bytes(x.Payload)
		} else {
			out.String("")
		}
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *Object) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *Object) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "objectID":
			{
				var f *grpc.ObjectID
				f = new(grpc.ObjectID)
				f.UnmarshalEasyJSON(in)
				x.ObjectId = f
			}
		case "signature":
			{
				var f *grpc.Signature
				f = new(grpc.Signature)
				f.UnmarshalEasyJSON(in)
				x.Signature = f
			}
		case "header":
			{
				var f *Header
				f = new(Header)
				f.UnmarshalEasyJSON(in)
				x.Header = f
			}
		case "payload":
			{
				var f []byte
				{
					tmp := in.Bytes()
					if len(tmp) == 0 {
						tmp = nil
					}
					f = tmp
				}
				x.Payload = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type SplitInfo struct {
	SplitId  []byte         `json:"splitId"`
	LastPart *grpc.ObjectID `json:"lastPart"`
	Link     *grpc.ObjectID `json:"link"`
}

var (
	_ encoding.ProtoMarshaler   = (*SplitInfo)(nil)
	_ encoding.ProtoUnmarshaler = (*SplitInfo)(nil)
	_ json.Marshaler            = (*SplitInfo)(nil)
	_ json.Unmarshaler          = (*SplitInfo)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *SplitInfo) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.BytesSize(1, x.SplitId)
	size += proto.NestedStructureSize(2, x.LastPart)
	size += proto.NestedStructureSize(3, x.Link)
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *SplitInfo) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *SplitInfo) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if len(x.SplitId) != 0 {
		mm.AppendBytes(1, x.SplitId)
	}
	if x.LastPart != nil {
		x.LastPart.EmitProtobuf(mm.AppendMessage(2))
	}
	if x.Link != nil {
		x.Link.EmitProtobuf(mm.AppendMessage(3))
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *SplitInfo) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "SplitInfo")
		}
		switch fc.FieldNum {
		case 1: // SplitId
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "SplitId")
			}
			x.SplitId = data
		case 2: // LastPart
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "LastPart")
			}
			x.LastPart = new(grpc.ObjectID)
			if err := x.LastPart.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 3: // Link
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Link")
			}
			x.Link = new(grpc.ObjectID)
			if err := x.Link.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		}
	}
	return nil
}
func (x *SplitInfo) GetSplitId() []byte {
	if x != nil {
		return x.SplitId
	}
	return nil
}
func (x *SplitInfo) SetSplitId(v []byte) {
	x.SplitId = v
}
func (x *SplitInfo) GetLastPart() *grpc.ObjectID {
	if x != nil {
		return x.LastPart
	}
	return nil
}
func (x *SplitInfo) SetLastPart(v *grpc.ObjectID) {
	x.LastPart = v
}
func (x *SplitInfo) GetLink() *grpc.ObjectID {
	if x != nil {
		return x.Link
	}
	return nil
}
func (x *SplitInfo) SetLink(v *grpc.ObjectID) {
	x.Link = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *SplitInfo) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *SplitInfo) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"splitId\":"
		out.RawString(prefix)
		if x.SplitId != nil {
			out.Base64Bytes(x.SplitId)
		} else {
			out.String("")
		}
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"lastPart\":"
		out.RawString(prefix)
		x.LastPart.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"link\":"
		out.RawString(prefix)
		x.Link.MarshalEasyJSON(out)
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *SplitInfo) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *SplitInfo) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "splitId":
			{
				var f []byte
				{
					tmp := in.Bytes()
					if len(tmp) == 0 {
						tmp = nil
					}
					f = tmp
				}
				x.SplitId = f
			}
		case "lastPart":
			{
				var f *grpc.ObjectID
				f = new(grpc.ObjectID)
				f.UnmarshalEasyJSON(in)
				x.LastPart = f
			}
		case "link":
			{
				var f *grpc.ObjectID
				f = new(grpc.ObjectID)
				f.UnmarshalEasyJSON(in)
				x.Link = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type ECInfo_Chunk struct {
	Id    *grpc.ObjectID `json:"id"`
	Index uint32         `json:"index"`
	Total uint32         `json:"total"`
}

var (
	_ encoding.ProtoMarshaler   = (*ECInfo_Chunk)(nil)
	_ encoding.ProtoUnmarshaler = (*ECInfo_Chunk)(nil)
	_ json.Marshaler            = (*ECInfo_Chunk)(nil)
	_ json.Unmarshaler          = (*ECInfo_Chunk)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *ECInfo_Chunk) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.NestedStructureSize(1, x.Id)
	size += proto.UInt32Size(2, x.Index)
	size += proto.UInt32Size(3, x.Total)
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *ECInfo_Chunk) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *ECInfo_Chunk) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if x.Id != nil {
		x.Id.EmitProtobuf(mm.AppendMessage(1))
	}
	if x.Index != 0 {
		mm.AppendUint32(2, x.Index)
	}
	if x.Total != 0 {
		mm.AppendUint32(3, x.Total)
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *ECInfo_Chunk) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "ECInfo_Chunk")
		}
		switch fc.FieldNum {
		case 1: // Id
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Id")
			}
			x.Id = new(grpc.ObjectID)
			if err := x.Id.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 2: // Index
			data, ok := fc.Uint32()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Index")
			}
			x.Index = data
		case 3: // Total
			data, ok := fc.Uint32()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Total")
			}
			x.Total = data
		}
	}
	return nil
}
func (x *ECInfo_Chunk) GetId() *grpc.ObjectID {
	if x != nil {
		return x.Id
	}
	return nil
}
func (x *ECInfo_Chunk) SetId(v *grpc.ObjectID) {
	x.Id = v
}
func (x *ECInfo_Chunk) GetIndex() uint32 {
	if x != nil {
		return x.Index
	}
	return 0
}
func (x *ECInfo_Chunk) SetIndex(v uint32) {
	x.Index = v
}
func (x *ECInfo_Chunk) GetTotal() uint32 {
	if x != nil {
		return x.Total
	}
	return 0
}
func (x *ECInfo_Chunk) SetTotal(v uint32) {
	x.Total = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *ECInfo_Chunk) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *ECInfo_Chunk) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"id\":"
		out.RawString(prefix)
		x.Id.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"index\":"
		out.RawString(prefix)
		out.Uint32(x.Index)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"total\":"
		out.RawString(prefix)
		out.Uint32(x.Total)
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *ECInfo_Chunk) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *ECInfo_Chunk) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "id":
			{
				var f *grpc.ObjectID
				f = new(grpc.ObjectID)
				f.UnmarshalEasyJSON(in)
				x.Id = f
			}
		case "index":
			{
				var f uint32
				r := in.JsonNumber()
				n := r.String()
				v, err := strconv.ParseUint(n, 10, 32)
				if err != nil {
					in.AddError(err)
					return
				}
				pv := uint32(v)
				f = pv
				x.Index = f
			}
		case "total":
			{
				var f uint32
				r := in.JsonNumber()
				n := r.String()
				v, err := strconv.ParseUint(n, 10, 32)
				if err != nil {
					in.AddError(err)
					return
				}
				pv := uint32(v)
				f = pv
				x.Total = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type ECInfo struct {
	Chunks []ECInfo_Chunk `json:"chunks"`
}

var (
	_ encoding.ProtoMarshaler   = (*ECInfo)(nil)
	_ encoding.ProtoUnmarshaler = (*ECInfo)(nil)
	_ json.Marshaler            = (*ECInfo)(nil)
	_ json.Unmarshaler          = (*ECInfo)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *ECInfo) StableSize() (size int) {
	if x == nil {
		return 0
	}
	for i := range x.Chunks {
		size += proto.NestedStructureSizeUnchecked(1, &x.Chunks[i])
	}
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *ECInfo) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *ECInfo) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	for i := range x.Chunks {
		x.Chunks[i].EmitProtobuf(mm.AppendMessage(1))
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *ECInfo) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "ECInfo")
		}
		switch fc.FieldNum {
		case 1: // Chunks
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Chunks")
			}
			x.Chunks = append(x.Chunks, ECInfo_Chunk{})
			ff := &x.Chunks[len(x.Chunks)-1]
			if err := ff.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		}
	}
	return nil
}
func (x *ECInfo) GetChunks() []ECInfo_Chunk {
	if x != nil {
		return x.Chunks
	}
	return nil
}
func (x *ECInfo) SetChunks(v []ECInfo_Chunk) {
	x.Chunks = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *ECInfo) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *ECInfo) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"chunks\":"
		out.RawString(prefix)
		out.RawByte('[')
		for i := range x.Chunks {
			if i != 0 {
				out.RawByte(',')
			}
			x.Chunks[i].MarshalEasyJSON(out)
		}
		out.RawByte(']')
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *ECInfo) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *ECInfo) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "chunks":
			{
				var f ECInfo_Chunk
				var list []ECInfo_Chunk
				in.Delim('[')
				for !in.IsDelim(']') {
					f = ECInfo_Chunk{}
					f.UnmarshalEasyJSON(in)
					list = append(list, f)
					in.WantComma()
				}
				x.Chunks = list
				in.Delim(']')
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}
