// Code generated by protoc-gen-go-frostfs. DO NOT EDIT.

package tombstone

import (
	json "encoding/json"
	fmt "fmt"
	grpc "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/refs/grpc"
	pool "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/util/pool"
	proto "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/util/proto"
	encoding "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/util/proto/encoding"
	easyproto "github.com/VictoriaMetrics/easyproto"
	jlexer "github.com/mailru/easyjson/jlexer"
	jwriter "github.com/mailru/easyjson/jwriter"
	strconv "strconv"
)

type Tombstone struct {
	ExpirationEpoch uint64          `json:"expirationEpoch"`
	SplitId         []byte          `json:"splitID"`
	Members         []grpc.ObjectID `json:"members"`
}

var (
	_ encoding.ProtoMarshaler   = (*Tombstone)(nil)
	_ encoding.ProtoUnmarshaler = (*Tombstone)(nil)
	_ json.Marshaler            = (*Tombstone)(nil)
	_ json.Unmarshaler          = (*Tombstone)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *Tombstone) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.UInt64Size(1, x.ExpirationEpoch)
	size += proto.BytesSize(2, x.SplitId)
	for i := range x.Members {
		size += proto.NestedStructureSizeUnchecked(3, &x.Members[i])
	}
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *Tombstone) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *Tombstone) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if x.ExpirationEpoch != 0 {
		mm.AppendUint64(1, x.ExpirationEpoch)
	}
	if len(x.SplitId) != 0 {
		mm.AppendBytes(2, x.SplitId)
	}
	for i := range x.Members {
		x.Members[i].EmitProtobuf(mm.AppendMessage(3))
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *Tombstone) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "Tombstone")
		}
		switch fc.FieldNum {
		case 1: // ExpirationEpoch
			data, ok := fc.Uint64()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "ExpirationEpoch")
			}
			x.ExpirationEpoch = data
		case 2: // SplitId
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "SplitId")
			}
			x.SplitId = data
		case 3: // Members
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Members")
			}
			x.Members = append(x.Members, grpc.ObjectID{})
			ff := &x.Members[len(x.Members)-1]
			if err := ff.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		}
	}
	return nil
}
func (x *Tombstone) GetExpirationEpoch() uint64 {
	if x != nil {
		return x.ExpirationEpoch
	}
	return 0
}
func (x *Tombstone) SetExpirationEpoch(v uint64) {
	x.ExpirationEpoch = v
}
func (x *Tombstone) GetSplitId() []byte {
	if x != nil {
		return x.SplitId
	}
	return nil
}
func (x *Tombstone) SetSplitId(v []byte) {
	x.SplitId = v
}
func (x *Tombstone) GetMembers() []grpc.ObjectID {
	if x != nil {
		return x.Members
	}
	return nil
}
func (x *Tombstone) SetMembers(v []grpc.ObjectID) {
	x.Members = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *Tombstone) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *Tombstone) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"expirationEpoch\":"
		out.RawString(prefix)
		out.RawByte('"')
		out.Buffer.Buf = strconv.AppendUint(out.Buffer.Buf, x.ExpirationEpoch, 10)
		out.RawByte('"')
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"splitID\":"
		out.RawString(prefix)
		if x.SplitId != nil {
			out.Base64Bytes(x.SplitId)
		} else {
			out.String("")
		}
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"members\":"
		out.RawString(prefix)
		out.RawByte('[')
		for i := range x.Members {
			if i != 0 {
				out.RawByte(',')
			}
			x.Members[i].MarshalEasyJSON(out)
		}
		out.RawByte(']')
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *Tombstone) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *Tombstone) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "expirationEpoch":
			{
				var f uint64
				r := in.JsonNumber()
				n := r.String()
				v, err := strconv.ParseUint(n, 10, 64)
				if err != nil {
					in.AddError(err)
					return
				}
				pv := uint64(v)
				f = pv
				x.ExpirationEpoch = f
			}
		case "splitID":
			{
				var f []byte
				{
					tmp := in.Bytes()
					if len(tmp) == 0 {
						tmp = nil
					}
					f = tmp
				}
				x.SplitId = f
			}
		case "members":
			{
				var f grpc.ObjectID
				var list []grpc.ObjectID
				in.Delim('[')
				for !in.IsDelim(']') {
					f = grpc.ObjectID{}
					f.UnmarshalEasyJSON(in)
					list = append(list, f)
					in.WantComma()
				}
				x.Members = list
				in.Delim(']')
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}
